// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from sick_safevisionary_interfaces:msg/GeneralStatus.idl
// generated code does not contain a copyright notice
#include "sick_safevisionary_interfaces/msg/detail/general_status__rosidl_typesupport_fastrtps_cpp.hpp"
#include "sick_safevisionary_interfaces/msg/detail/general_status__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions

namespace sick_safevisionary_interfaces
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_sick_safevisionary_interfaces
cdr_serialize(
  const sick_safevisionary_interfaces::msg::GeneralStatus & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: run_mode_active
  cdr << ros_message.run_mode_active;
  // Member: device_error
  cdr << ros_message.device_error;
  // Member: application_error
  cdr << ros_message.application_error;
  // Member: sleep_mode
  cdr << ros_message.sleep_mode;
  // Member: wait_for_input
  cdr << ros_message.wait_for_input;
  // Member: wait_for_cluster
  cdr << ros_message.wait_for_cluster;
  // Member: contamination_warning
  cdr << ros_message.contamination_warning;
  // Member: contamination_error
  cdr << ros_message.contamination_error;
  // Member: dead_zone_detection
  cdr << ros_message.dead_zone_detection;
  // Member: temperature_warning
  cdr << ros_message.temperature_warning;
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_sick_safevisionary_interfaces
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  sick_safevisionary_interfaces::msg::GeneralStatus & ros_message)
{
  // Member: run_mode_active
  cdr >> ros_message.run_mode_active;

  // Member: device_error
  cdr >> ros_message.device_error;

  // Member: application_error
  cdr >> ros_message.application_error;

  // Member: sleep_mode
  cdr >> ros_message.sleep_mode;

  // Member: wait_for_input
  cdr >> ros_message.wait_for_input;

  // Member: wait_for_cluster
  cdr >> ros_message.wait_for_cluster;

  // Member: contamination_warning
  cdr >> ros_message.contamination_warning;

  // Member: contamination_error
  cdr >> ros_message.contamination_error;

  // Member: dead_zone_detection
  cdr >> ros_message.dead_zone_detection;

  // Member: temperature_warning
  cdr >> ros_message.temperature_warning;

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_sick_safevisionary_interfaces
get_serialized_size(
  const sick_safevisionary_interfaces::msg::GeneralStatus & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: run_mode_active
  {
    size_t item_size = sizeof(ros_message.run_mode_active);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: device_error
  {
    size_t item_size = sizeof(ros_message.device_error);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: application_error
  {
    size_t item_size = sizeof(ros_message.application_error);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: sleep_mode
  {
    size_t item_size = sizeof(ros_message.sleep_mode);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: wait_for_input
  {
    size_t item_size = sizeof(ros_message.wait_for_input);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: wait_for_cluster
  {
    size_t item_size = sizeof(ros_message.wait_for_cluster);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: contamination_warning
  {
    size_t item_size = sizeof(ros_message.contamination_warning);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: contamination_error
  {
    size_t item_size = sizeof(ros_message.contamination_error);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: dead_zone_detection
  {
    size_t item_size = sizeof(ros_message.dead_zone_detection);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: temperature_warning
  {
    size_t item_size = sizeof(ros_message.temperature_warning);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_sick_safevisionary_interfaces
max_serialized_size_GeneralStatus(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  size_t last_member_size = 0;
  (void)last_member_size;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;


  // Member: run_mode_active
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: device_error
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: application_error
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: sleep_mode
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: wait_for_input
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: wait_for_cluster
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: contamination_warning
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: contamination_error
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: dead_zone_detection
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: temperature_warning
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  size_t ret_val = current_alignment - initial_alignment;
  if (is_plain) {
    // All members are plain, and type is not empty.
    // We still need to check that the in-memory alignment
    // is the same as the CDR mandated alignment.
    using DataType = sick_safevisionary_interfaces::msg::GeneralStatus;
    is_plain =
      (
      offsetof(DataType, temperature_warning) +
      last_member_size
      ) == ret_val;
  }

  return ret_val;
}

static bool _GeneralStatus__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const sick_safevisionary_interfaces::msg::GeneralStatus *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _GeneralStatus__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<sick_safevisionary_interfaces::msg::GeneralStatus *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _GeneralStatus__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const sick_safevisionary_interfaces::msg::GeneralStatus *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _GeneralStatus__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_GeneralStatus(full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}

static message_type_support_callbacks_t _GeneralStatus__callbacks = {
  "sick_safevisionary_interfaces::msg",
  "GeneralStatus",
  _GeneralStatus__cdr_serialize,
  _GeneralStatus__cdr_deserialize,
  _GeneralStatus__get_serialized_size,
  _GeneralStatus__max_serialized_size
};

static rosidl_message_type_support_t _GeneralStatus__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_GeneralStatus__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace sick_safevisionary_interfaces

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_sick_safevisionary_interfaces
const rosidl_message_type_support_t *
get_message_type_support_handle<sick_safevisionary_interfaces::msg::GeneralStatus>()
{
  return &sick_safevisionary_interfaces::msg::typesupport_fastrtps_cpp::_GeneralStatus__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, sick_safevisionary_interfaces, msg, GeneralStatus)() {
  return &sick_safevisionary_interfaces::msg::typesupport_fastrtps_cpp::_GeneralStatus__handle;
}

#ifdef __cplusplus
}
#endif
