// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from sick_safevisionary_interfaces:msg/ROI.idl
// generated code does not contain a copyright notice
#include "sick_safevisionary_interfaces/msg/detail/roi__rosidl_typesupport_fastrtps_cpp.hpp"
#include "sick_safevisionary_interfaces/msg/detail/roi__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace sick_safevisionary_interfaces
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const sick_safevisionary_interfaces::msg::ROIObservationResultData &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  sick_safevisionary_interfaces::msg::ROIObservationResultData &);
size_t get_serialized_size(
  const sick_safevisionary_interfaces::msg::ROIObservationResultData &,
  size_t current_alignment);
size_t
max_serialized_size_ROIObservationResultData(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace sick_safevisionary_interfaces

namespace sick_safevisionary_interfaces
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const sick_safevisionary_interfaces::msg::ROIObservationSafetyData &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  sick_safevisionary_interfaces::msg::ROIObservationSafetyData &);
size_t get_serialized_size(
  const sick_safevisionary_interfaces::msg::ROIObservationSafetyData &,
  size_t current_alignment);
size_t
max_serialized_size_ROIObservationSafetyData(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace sick_safevisionary_interfaces


namespace sick_safevisionary_interfaces
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_sick_safevisionary_interfaces
cdr_serialize(
  const sick_safevisionary_interfaces::msg::ROI & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: id
  cdr << ros_message.id;
  // Member: result_data
  sick_safevisionary_interfaces::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.result_data,
    cdr);
  // Member: safety_data
  sick_safevisionary_interfaces::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.safety_data,
    cdr);
  // Member: distance_value
  cdr << ros_message.distance_value;
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_sick_safevisionary_interfaces
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  sick_safevisionary_interfaces::msg::ROI & ros_message)
{
  // Member: id
  cdr >> ros_message.id;

  // Member: result_data
  sick_safevisionary_interfaces::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.result_data);

  // Member: safety_data
  sick_safevisionary_interfaces::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.safety_data);

  // Member: distance_value
  cdr >> ros_message.distance_value;

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_sick_safevisionary_interfaces
get_serialized_size(
  const sick_safevisionary_interfaces::msg::ROI & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: id
  {
    size_t item_size = sizeof(ros_message.id);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: result_data

  current_alignment +=
    sick_safevisionary_interfaces::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.result_data, current_alignment);
  // Member: safety_data

  current_alignment +=
    sick_safevisionary_interfaces::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.safety_data, current_alignment);
  // Member: distance_value
  {
    size_t item_size = sizeof(ros_message.distance_value);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_sick_safevisionary_interfaces
max_serialized_size_ROI(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  size_t last_member_size = 0;
  (void)last_member_size;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;


  // Member: id
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: result_data
  {
    size_t array_size = 1;


    last_member_size = 0;
    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      size_t inner_size =
        sick_safevisionary_interfaces::msg::typesupport_fastrtps_cpp::max_serialized_size_ROIObservationResultData(
        inner_full_bounded, inner_is_plain, current_alignment);
      last_member_size += inner_size;
      current_alignment += inner_size;
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  // Member: safety_data
  {
    size_t array_size = 1;


    last_member_size = 0;
    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      size_t inner_size =
        sick_safevisionary_interfaces::msg::typesupport_fastrtps_cpp::max_serialized_size_ROIObservationSafetyData(
        inner_full_bounded, inner_is_plain, current_alignment);
      last_member_size += inner_size;
      current_alignment += inner_size;
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  // Member: distance_value
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint16_t);
    current_alignment += array_size * sizeof(uint16_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint16_t));
  }

  size_t ret_val = current_alignment - initial_alignment;
  if (is_plain) {
    // All members are plain, and type is not empty.
    // We still need to check that the in-memory alignment
    // is the same as the CDR mandated alignment.
    using DataType = sick_safevisionary_interfaces::msg::ROI;
    is_plain =
      (
      offsetof(DataType, distance_value) +
      last_member_size
      ) == ret_val;
  }

  return ret_val;
}

static bool _ROI__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const sick_safevisionary_interfaces::msg::ROI *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _ROI__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<sick_safevisionary_interfaces::msg::ROI *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _ROI__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const sick_safevisionary_interfaces::msg::ROI *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _ROI__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_ROI(full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}

static message_type_support_callbacks_t _ROI__callbacks = {
  "sick_safevisionary_interfaces::msg",
  "ROI",
  _ROI__cdr_serialize,
  _ROI__cdr_deserialize,
  _ROI__get_serialized_size,
  _ROI__max_serialized_size
};

static rosidl_message_type_support_t _ROI__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_ROI__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace sick_safevisionary_interfaces

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_sick_safevisionary_interfaces
const rosidl_message_type_support_t *
get_message_type_support_handle<sick_safevisionary_interfaces::msg::ROI>()
{
  return &sick_safevisionary_interfaces::msg::typesupport_fastrtps_cpp::_ROI__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, sick_safevisionary_interfaces, msg, ROI)() {
  return &sick_safevisionary_interfaces::msg::typesupport_fastrtps_cpp::_ROI__handle;
}

#ifdef __cplusplus
}
#endif
